<?xml version="1.0" encoding="UTF-8"?>

<?import javafx.geometry.Insets?>
<?import javafx.scene.control.*?>
<?import javafx.scene.image.ImageView?>
<?import javafx.scene.layout.*?>
<?import java.net.URL?>
<AnchorPane fx:id="mainAnchorPane" prefHeight="600" prefWidth="600" xmlns:fx="http://javafx.com/fxml" fx:controller="com.alanmrace.jimzmlvalidator.gui.ImzMLValidatorController">
    <stylesheets>
        <URL value="@/styles/draganddropscene.css"/>
    </stylesheets>
    <HBox alignment="CENTER" fx:id="optionsBox" spacing="10" AnchorPane.topAnchor="75.0" AnchorPane.bottomAnchor="10.0" AnchorPane.leftAnchor="10.0" AnchorPane.rightAnchor="10.0">
        <VBox HBox.hgrow="ALWAYS" spacing="5" fx:id="leftSideVBox">
            <HBox alignment="CENTER">
                <ImageView fx:id="imageView" preserveRatio="true" smooth="false"></ImageView>
            </HBox>
            <Accordion VBox.vgrow="SOMETIMES">
                <panes>
                    <TitledPane text="Report">
                        <content>
                            <TextArea fx:id="textArea" ></TextArea>
                        </content>
                    </TitledPane>
                </panes>
            </Accordion>
            <Accordion VBox.vgrow="ALWAYS">
                <panes>
                    <TitledPane text="Full imzML">
                        <content>
                            <VBox spacing="0" AnchorPane.bottomAnchor="0.0" AnchorPane.leftAnchor="0.0" AnchorPane.rightAnchor="0.0" AnchorPane.topAnchor="0.0">
                                <padding><Insets top="0" right="0" bottom="0" left="0"/></padding>
                                
                                <TextField fx:id="searchTreeText"></TextField>
                                <TreeView fx:id="treeView" VBox.vgrow="ALWAYS"></TreeView>
                                <ListView fx:id="treeSearchResultsView" visible="false" VBox.vgrow="ALWAYS"></ListView>
                            </VBox>
                        </content>
                    </TitledPane>
                </panes>
            </Accordion>
        </VBox>
        <VBox HBox.hgrow="ALWAYS" alignment="CENTER">
            <spacing>5</spacing>
            <Accordion>
                <panes>
                    <TitledPane text="Options">
                        <content>
                            <GridPane vgap="5.0" AnchorPane.leftAnchor="5.0" AnchorPane.rightAnchor="5.0" AnchorPane.topAnchor="5.0">
                                <padding>
                                    <Insets top="10" right="10" bottom="10" left="10"/>
                                </padding>
                                <columnConstraints>
                                    <ColumnConstraints hgrow="ALWAYS" />
                                </columnConstraints>
                                <children>
                                        <CheckBox fx:id="skipHashCheckCheckBox" text="Skip data integrity check."  GridPane.columnIndex="0" GridPane.rowIndex="0"></CheckBox>
                                        <VBox GridPane.columnIndex="0" GridPane.rowIndex="1">
                                            <TableView fx:id="mappingListView" GridPane.hgrow="ALWAYS">
                                                <columns>
                                                    <TableColumn text="Include"></TableColumn>
                                                    <TableColumn text="Mapping File"></TableColumn>
                                                    <TableColumn text="Version"></TableColumn>
                                                    <!--<TableColumn text="Remove"></TableColumn>-->
                                                </columns>
                                            </TableView>
                                            <HBox GridPane.columnIndex="0" GridPane.rowIndex="2">
                                                <Button text="Add" onAction="#addMappingFileClicked">
                                                    <tooltip>
                                                        <Tooltip text="Add custom mapping file to the list." />
                                                    </tooltip>
                                                </Button>
                                                <Button text="Update">
                                                    <tooltip>
                                                        <Tooltip text="Update builtin mapping files to latest versions (requires an internet connection)." />
                                                    </tooltip>
                                                </Button>
                                            </HBox>
                                        </VBox>
                                        <VBox GridPane.columnIndex="0" GridPane.rowIndex="2">
                                            <TableView fx:id="conditionalMappingListView" GridPane.hgrow="ALWAYS" >
                                                <columns>
                                                    <TableColumn text="Include"></TableColumn>
                                                    <TableColumn text="Conditional Mapping File"></TableColumn>
                                                    <TableColumn text="Version"></TableColumn>
                                                    <!--<TableColumn text="Remove"></TableColumn>-->
                                                </columns>
                                            </TableView>
                                            <Button text="Add" onAction="#addConditionalMappingFileClicked"></Button>
                                        </VBox>
                                        <!--<ComboBox promptText="Reporting level" >
                                            <items>
                                                <FXCollections fx:factory="observableArrayList">
                                                    <String fx:value="Full" />
                                                    <String fx:value="Almost full" />
                                                    <String fx:value="May" />
                                                    <String fx:value="Should" />
                                                    <String fx:value="Must" />
                                                </FXCollections>
                                            </items>
                                            <value>
                                                <String fx:value="Almost full" />
                                            </value>
                                        </ComboBox>
                                        <Button text="Update"></Button>-->
                                </children>
                            </GridPane >
                        </content>
                    </TitledPane>
                </panes>
            </Accordion>
            <Button fx:id="validateButton" alignment="CENTER" prefHeight="20" prefWidth="500" text="Validate" onAction="#validateButtonAction" />
            <HBox alignment="CENTER" prefHeight="20">
                <Label fx:id="progressLabel" prefWidth="300" text="" HBox.hgrow="ALWAYS"></Label>
                <ProgressBar prefWidth="200" fx:id="progressBar" progress="0.0" HBox.hgrow="ALWAYS"></ProgressBar>
            </HBox>
            <Accordion>
                <panes>
                    <TitledPane text="Filter">
                        <content>
                            <GridPane>
                                <padding>
                                    <Insets top="10" right="10" bottom="10" left="10"/>
                                </padding>
                                <children>
                                    <HBox>
                                        <CheckBox fx:id="hideUncheckableRules" text="Hide uncheckable rules." onAction="#hideUncheckableRulesAction"></CheckBox>
                                        <CheckBox fx:id="sortIssueList" text="Sort issue list." onAction="#sortIssueListAction"></CheckBox>
                                    </HBox>
                                </children>
                            </GridPane >
                        </content>
                    </TitledPane>
                </panes>
            </Accordion>
            <ListView fx:id="resultsListView" VBox.vgrow="ALWAYS" onMouseClicked="#listViewClicked">
            </ListView>
            <HBox>
                <Pane HBox.hgrow="ALWAYS" />
                <Button fx:id="saveAsButton" onAction="#saveAsButtonClicked" prefWidth="75">Save As</Button>
                <Button fx:id="saveButton" onAction="#saveButtonClicked" prefWidth="75">Save</Button>
            </HBox>
        </VBox>
    </HBox>
    <VBox  alignment="CENTER" fx:id="dropBox" layoutX="50" layoutY="100" onMouseClicked="#fileBoxClicked" onDragOver="#fileBoxDragOver" onDragDropped="#fileBoxDragDropped" prefHeight="50" AnchorPane.leftAnchor="50.0" AnchorPane.rightAnchor="50.0">
        <TextField fx:id="dropLocation" onMouseClicked="#fileBoxClicked"  onDragOver="#fileBoxDragOver" onDragDropped="#fileBoxDragDropped"  editable="false" alignment="CENTER"   prefHeight="50" prefWidth="550" disable="true" >Drop or click here!</TextField>  
    </VBox>
</AnchorPane>
